import urllib2
import re
from lxml import html
#
#
Main_URL= 'https://imgtag.co.kr'
LOGIN_URL = 'https://imgtag.co.kr/login'
SEARCH_URL = 'https://imgtag.co.kr/newdrama/?mod=list&pageid=1&target=kboard_option_nvtag_key&kboard_search_option[key2][compare]=LIKE&keyword='
TEXT_SEARCH_URL = 'https://imgtag.co.kr/newdrama/?mod=list&pageid=1&target=title&kboard_search_option[tag_key][compare]=LIKE&keyword='
DETAIL_URL = 'https://imgtag.co.kr/newdrama/?uid=%s&mod=document&pageid=1'
SUB_URL = 'https://imgtag.co.kr/images/sub'



global COOKIE_VALUE
class OS_Search_Methode:
    Hash, IMDB, Name = range(0, 3)


def Start():
  HTTP.CacheTime = 0
  HTTP.Headers['User-Agent'] = 'Plex Media Server/%s' % Platform.ServerVersion
  HTTP.Headers['Cookie'] = 'cok=1'











def getLangList():
  langList = [Prefs["langPref1"]]
  return langList


def downloadBestSubtitle(subtitleResponse, part, language, title, duration):
  subUrl = SUB_URL + '/' + title + '/' + duration + '.srt'

  try:
    req = urllib2.Request(subUrl)
    subGz = urllib2.urlopen(req).read()
  except Exception as e:
    Log.Error("3.subtitle, Exception: '%s'" % e)
    return False
  else:
    part.subtitles[Locale.Language.Match(language)][subUrl] = Proxy.Media(subGz, ext='srt')
    return True

def downloadBestSubtitle2(subtitleResponse, part, language, opensub):
  subUrl = SUB_URL + '/' + opensub + '.srt'

  try:
    req = urllib2.Request(subUrl)
    subGz = urllib2.urlopen(req).read()
  except Exception as e:
    Log.Error("3.subtitle, Exception: '%s'" % e)
    return False
  else:
    part.subtitles[Locale.Language.Match(language)][subUrl] = Proxy.Media(subGz, ext='srt')
    return True


def request(url):
  global COOKIE_VALUE
  req = urllib2.Request(url)
  req.add_header('cookie',COOKIE_VALUE)
  response = urllib2.urlopen(req)
  return response.read()


def LoginCookie():
  User_ID = Prefs['username'] if Prefs['username'] else ''
  User_PASS = Prefs['password'] if Prefs['password'] else ''

  LOGIN_INFO = {
    'redirect_to': "https://imgtag.co.kr",
    'a': 'login',
    'log': User_ID,
    'pwd': User_PASS
  }
  COOKIE_VALUE = ""
  if User_ID != "":
    request = HTTP.Request("https://imgtag.co.kr/login/", LOGIN_INFO)

    COOKIE_VALUE = HTTP.CookiesForURL("https://imgtag.co.kr/login/")


  return(COOKIE_VALUE)







class AvAgent(Agent.Movies):
  name = 'AvImgTag'
  primary_provider = True

  languages = [ Locale.Language.English, Locale.Language.Korean, Locale.Language.Japanese]

  accepts_from = ['com.plexapp.agents.localmedia']
  global COOKIE_VALUE
  COOKIE_VALUE = LoginCookie()

  if COOKIE_VALUE != "":
    Log("Login Success")




  def search(self, results, media, lang, manual):
    searchResult = False
    MediaURL = []
    mvName = []

    global COOKIE_VALUE

    if media.openSubtitlesHash == None:
      SubtitleHash = 'nonehash'
    else:
      SubtitleHash = media.openSubtitlesHash


    if str(media.duration) != '-1':
        str_duration = str(media.duration)
    else:
        str_duration = ""
    ############################

    header = {'cookie': COOKIE_VALUE}

    url = SEARCH_URL + SubtitleHash



    try:
      html3 = html.fromstring(request(url))
    except Exception as e:
      Log.Error("1.TVDB Loading search XML failed, Exception: '%s'" % e)

    else:
      for movieURL in html3.xpath('//td[contains(@class,"kboard-list-title")]/a/@href'):
        MediaURL.append(movieURL)

      for movieName in html3.xpath('//div[contains(@class,"kboard-default-cut-string")]/text()'):
        movieName = movieName.replace(' ','')
        movieName = movieName.strip()
        if movieName != "":
          mvName.append(movieName)

      if len(MediaURL) == 0:

        code_match_pattern1 = '[a-zA-Z]{2,5}'
        code_match_pattern2 = '[0-9]{2,5}'
        re_rules1 = re.compile(code_match_pattern1, flags=re.IGNORECASE)
        re_rules2 = re.compile(code_match_pattern2, flags=re.IGNORECASE)

        file_code = True
        file_code1 = re_rules1.findall(media.name)
        file_code2 = re_rules2.findall(media.name)

        if not file_code1:
          file_code = False
        if not file_code2:
          file_code = False

        if file_code == True:

          NameUrlx = file_code1[0]+ '-' +file_code2[0]
          NameUrlx = NameUrlx.lower()

          NameUrlx = TEXT_SEARCH_URL + NameUrlx
          try:
            html2 = html.fromstring(request(NameUrlx))

          except Exception as e:
            Log.Error("2.TVDB Loading search XML failed, Exception: '%s'" % e)
          else:
            for movieURL in html2.xpath('//td[contains(@class,"kboard-list-title")]/a/@href'):
              MediaURL.append(movieURL)

            for movieName in html2.xpath('//div[contains(@class,"kboard-default-cut-string")]/text()'):
              movieName = movieName.replace(' ', '')
              movieName = movieName.strip()
              if movieName != "":
                mvName.append(movieName)
  
      if len(MediaURL) == 0:

        media_file_name =  media.name
        media_file_name = media_file_name.lower()

        if media_file_name.find('fc2') != -1:
          code_match_pattern1 = '[0-9]{5,8}'
          re_rules1 = re.compile(code_match_pattern1, flags=re.IGNORECASE)

          file_code = True
          file_code1 = re_rules1.findall(media.name)
          if not file_code1:
            file_code = False
          if file_code == True:

            NameUrlx = file_code1[0]

            NameUrlx = TEXT_SEARCH_URL + NameUrlx
          try:
            html2 = html.fromstring(request(NameUrlx))
          except Exception as e:
            Log.Error("2.TVDB Loading search XML failed, Exception: '%s'" % e)
          else:
            for movieURL in html2.xpath('//td[contains(@class,"kboard-list-title")]/a/@href'):
              MediaURL.append(movieURL)

            for movieName in html2.xpath('//div[contains(@class,"kboard-default-cut-string")]/text()'):
              movieName = movieName.replace(' ', '')
              movieName = movieName.strip()
              if movieName != "":
                mvName.append(movieName)
		
      cnt = 0
      for uid in MediaURL:
        uid = Regex('uid=.*').search(uid).group()
        uid = uid.replace('uid=','')
        uid = uid +  '|' + str_duration + '|' + SubtitleHash

        results.Append(MetadataSearchResult(id=uid, name=mvName[cnt], score=100, lang=lang))
        searchResult = True
        cnt = cnt + 1



    if searchResult == False:

      results.Append(MetadataSearchResult(id='null', score=100))


  def update(self, metadata, media, lang):
    global COOKIE_VALUE
    hangulposter = False

    metaid = metadata.id

    uid,duration,hashguid2 = metaid.split('|')
    titlename = ''



    header = {'cookie': COOKIE_VALUE}

    url = str(DETAIL_URL % (uid))


    try:
      html1 = html.fromstring(request(url))
    except:
      Log('AVIMGTAG was unable to get any metadata for %s (lang = %s)' % (metadata.id, lang))
    else:


      year = list()
      actors = list()
      roles =list()
      summary = list()
      posters = list()

      try:
        metadata.title = html1.xpath('//div[@class="kboard-title"]/h1/text()')[0].replace(":","")
        titlename = metadata.title

      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))


      try:
        metadata.original_title = html1.xpath('//div[@class="kboard-document-add-option-value meta-key-nvTitle"]/span[3]/div/@class')[0].replace(":","")
        metadata.title = metadata.title + ':' + metadata.original_title
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))


      try:
        if Prefs['posterselect'] == 'hangul':
          postersImg = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvposter2")]/span[3]/div/@id')
          if len(postersImg) == 0:
            postersImg = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvPoster")]/span[3]/div/@id')
          else:
            hangulposter = True
          if postersImg != None:
            metadata.posters[postersImg[0]] = Proxy.Preview(postersImg[0], sort_order=50)
        elif Prefs['posterselect'] == 'manga':
          postersImg = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvPoster")]/span[3]/div/@id')
          if postersImg != None:
            postersImg[0] = postersImg[0].replace('.jpg','.webp')
            metadata.posters[postersImg[0]] = Proxy.Preview(postersImg[0], sort_order=100)
        else:
          postersImg = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvPoster")]/span[3]/div/@id')
          if postersImg != None:
            metadata.posters[postersImg[0]] = Proxy.Preview(postersImg[0], sort_order=100)
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))


      try:
        year = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvDate")]/span[3]/text()')

        if year :
          year[0] = year[0].replace('.', '-')
          match = Regex(u'(\d{4}\-\d{2}\-\d{2})').search(year[0])

          if match:
            metadata.originally_available_at = Datetime.ParseDate(match.group(1)).date()
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))


      try:
        summary = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvStory")]/span[3]/div/@class')

        for summary0 in summary:
          metadata.summary = summary0.replace("<br />", "")
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))

      try:
        metadata.directors.clear()
        directors = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvDirector")]/span[3]/div/@id')

        for director in directors:

          director = director.replace(":", "")
          director = director.strip()
          if director != "":
            meta_director = metadata.directors.new()
            meta_director.name = director
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))

      try:
        metadata.roles.clear()
        actors = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvActor2")]/span[3]/a/text()')
        photos = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvActor2")]/span[3]/a/@href')
        
        if len(actors) == 0:
          actors = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvActor")]/span[3]/a/text()')
          photos = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvActor")]/span[3]/a/@href')



        if actors :
          for actor in actors:
            index = actors.index(actor);
            actor = actor.replace(":", "")
            actor = actor.strip()

            regJPG = re.compile("https?://.*?\.jpg")
            SearchJpg = regJPG.findall(photos[index])

            if actor != "":
              meta_role = metadata.roles.new()
              meta_role.name = actor

              if SearchJpg :
                if Prefs['posterselect'] == 'manga':
                  if len(SearchJpg[0]) >= 1:
                    SearchJpg[0] = SearchJpg[0].replace('.jpg', '.webp')
                meta_role.photo = SearchJpg[0]
      except Exception, e:
        Log('Error (%s) - %s' % (e, e.message))


      try:
        metadata.genres.clear()

        genres = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvGenre")]/span[3]/div/@id')
        for genre in genres:
          genre = genre.replace(":", "")
          genre = genre.strip()
          if genre == "\n":
            continue
          if genre == "":
            continue
          metadata.genres.add(genre)
        if hangulposter == True:
          metadata.genres.add('한글포스터')
      except Exception, e:
        Log('ErrorGenre (%s) - %s' % (e, e.message))




      try:
        studios = html1.xpath('//div[@class="kboard-document-add-option-value meta-key-nvStudio"]/span[3]/text()')
        for studio in studios:
          studio = studio.replace(":", "")
          studio = studio.strip()
          if studio != "":
            metadata.studio = studio
      except Exception, e:
        Log('ErrorStudio (%s) - %s' % (e, e.message))



      try:
        metadata.producers.clear()
        producerss = html1.xpath('//div[@class="kboard-document-add-option-value meta-key-nvProduce"]/span[3]/text()')
        for producer in producerss:
          producer = producer.replace(":", "")
          producer = producer.strip()
          if producer != "":
            #Log('producer : %s' % (producer))
            meta_producer = metadata.producers.new()
            meta_producer.name = producer

      except Exception, e:
        Log('ErrorProducer (%s) - %s' % (e, e.message))




      try:
        arts = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvArt")]/span[3]/div/@id')
        for art in arts:
          if Prefs['posterselect'] == 'manga':
            if len(art) >= 1:
              art = art.replace('.jpg','.webp')
          metadata.art[art] = Proxy.Preview(request(art), sort_order=len(metadata.art) + 1)

      except Exception, e:
        Log('ErrorART (%s) - %s' % (e, e.message))




      try:
        metadata.collections.clear()

        collections =  html1.xpath('//div[@class="kboard-document-add-option-value meta-key-nvCollection"]/span[3]/div/@class')
        for collection in collections:
          collection = collection.replace(":", "")
          collection = collection.strip()
          if collection != "" :
            metadata.collections.add(collection)
      except Exception, e:
        Log('ErrorCOL (%s) - %s' % (e, e.message))



      try:

        ratings = html1.xpath('//div[contains(@class,"kboard-document-add-option-value meta-key-nvRating")]/span[3]/text()')
        for rating in ratings:
          rating = rating.replace(":", "")
          metadata.rating =float(rating)
      except Exception, e:
        Log('ErrorRating (%s) - %s' % (e, e.message))





      for language in getLangList():
        if downloadBestSubtitle(False, media.items[0].parts[0], language, titlename, duration) == True:
          break
        else:
          downloadBestSubtitle2(False, media.items[0].parts[0], language, hashguid2)



